package ru.kristall.report;

import java.io.File;
import java.io.InputStream;
import java.net.JarURLConnection;
import java.net.URL;
import java.net.URLClassLoader;
import java.net.URLConnection;
import java.sql.Connection;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

import ru.kristall.*;
import ru.bitel.bgbilling.server.util.Setup;

//import ru.bitel.bgbilling.kernel.container.service.server.AbstractService;


public class RepManager {
	
	public String repName;
	public String repClass;
	public String repJar;
	public String repUser;
	public String repParam;
	public String repLogFileName;
	public String repEmail;
	
//	getConnection(), getSetup()
	
	
	private Hashtable h = new Hashtable();
//	private Properties h = new Properties();
	private BaseReport loaderReport=null;
	private Setup lSetup=null;
	private Connection lCon=null;
	private Logger lg=null;
	
	public RepManager() {}
	public RepManager(String rParam) {
		repParam=rParam;
		if (lg==null) {
		  lg = new Logger();
		  System.out.println("Logger");
		  if (lg!=null) System.out.println("Logger not null");
		  else System.out.println("Logger is null");
		  lg.setLogF("reports.log");
		  lg.initLog();		
		}
		parseParameter();
		
	}
	public void setRepName(String p) {repName=p;}
	public void setRepClass(String p) {repClass=p;}
	public void setRepJar(String p) {repJar=p;}
	public void setRepUser(String p) {repUser=p;}
	public void setRepParam(String p) {repParam=p;}
	public void setConnection(Connection con) {lCon=con;}
	public void setSetup(Setup pSetup) {lSetup=pSetup;} 

	public String getRepName() {return repName;}
	public String getRepClass() {return repClass;}
	public String getRepJar() {return repJar;}
	public String getRepUser() {return repUser;}
	public String getRepParam() {return repParam;}
	

	public void parseParameter() {
		h = new Hashtable();
//		h = new Properties();
		lg.logWrite("parse");
		StringTokenizer t = new StringTokenizer(repParam,";");
		lg.logWrite("repParam="+repParam);
		StringBuffer pn;
		StringBuffer pv;
		while(t.hasMoreTokens()) {
			StringTokenizer t1= new StringTokenizer (t.nextToken(),"|");
			pn= new StringBuffer("");
			pv= new StringBuffer("");
			int si=0;
			while(t1.hasMoreTokens()) {
				if (si==1) { pv.delete(0, pv.length()); pv.append(t1.nextToken());si++;}
				else if (si==0) { pn.delete(0, pn.length()); pn.append(t1.nextToken().toLowerCase());si++;}			
			}
			h.put(pn.toString(), pv.toString());
			lg.logWrite("pn="+pn+" pv="+pv);
		}
		repName=(String)h.get("name"); 
		repClass=(String)h.get("class");
		repJar=(String)h.get("urlj");
		repUser=(String)h.get("user");
		repEmail=(String)h.get("email");
		repLogFileName=(String)h.get("log");
		if (!repLogFileName.equalsIgnoreCase("reports.log")) {
			lg.endLog();
			lg.setLogF(repLogFileName);
			lg.initLog();
		}
	}
	

//	private void loadJar() {
//	  URLClassLoader ucl = null;
//      try {
//		URL url = new URL("jar:"+repJar+"!/");
//	    URL[] u = new URL[1];
//	    u[0]=url;
//	    ucl = new URLClassLoader(u);
//	    Class<?> clazz =ucl.loadClass(repClass);
//	    loaderReport = (BaseReport) clazz.newInstance();
//	    lg.logWrite("Loaded "+repJar);
//      }
//	  catch (Exception e) {
//	  lg.logWrite(e, "!+!+!+!+!+!+!+!+!+!+!+!++!+!+");
//	  }
//	}

	private void loadJar() {
	  try{
        int li = repClass.lastIndexOf(".");
        lg.logWrite("repClass="+repClass);
        lg.logWrite("li="+li);
		String repPackage = repClass.substring(0,li);
        lg.logWrite("repPackage="+repPackage);
		MyJarClassLoader mcl = new MyJarClassLoader(repJar,repPackage);
        lg.logWrite("repClass.substring(li)="+repClass.substring(li+1));
	    Class<?> clazz =mcl.loadClass(repClass.substring(li+1));
	    loaderReport = (BaseReport) clazz.newInstance();
	    lg.logWrite("Loaded "+repJar);
      }
	  catch (Exception e) {
		  lg.logWrite(e, "!+!+!+!+!+!+!+!+!+!+!+!++!+!+");
	  }
	}
	
	
	public String runReport() {
	  System.out.println("start");
	  String ret;
	  if (lg==null) {
        lg = new Logger();
	    System.out.println("Logger");
	    if (lg!=null) System.out.println("Logger not null");
	    else System.out.println("Logger is null");
	    lg.setLogF("reports.log");
	    lg.initLog();
	  }
	  try{
		System.out.println("logger");
//		lg.logWrite("before parse");
        //parseParameter();
//		lg.logWrite("parse");
        try { loadJar(); }
        catch(Exception e1) {lg.logWrite(e1, "loader");}
//		lg.logWrite("loadjar==========================");
//		lg.logWrite("===========================================================");
//		if (lSetup!=null) {lg.logWrite("lSetup !=null");}
//		else lg.logWrite("lSetup is null");
//		if (lCon!=null) {lg.logWrite("lCon is not null");}
//		else lg.logWrite("lCon is null");
		loaderReport.setLogger(lg);
		loaderReport.setParam(h);
		loaderReport.setSetup(lSetup);
		loaderReport.setConnection(lCon);
		loaderReport.setEmail(repEmail);
		
//		lg.logWrite("sets");
		
		loaderReport.start();
//		lg.logWrite("start");
		ret="Report executed";
		//lg.endLog();
	  }
	  catch (Exception e) { ret=e.getMessage(); }
      return ret;
	}
	
}
