package ru.kristall.alfresco.module.bg.constraints;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

import javax.faces.model.SelectItem;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.alfresco.repo.dictionary.constraint.ListOfValuesConstraint;
import org.alfresco.repo.model.Repository;
import org.alfresco.service.ServiceRegistry;
import org.alfresco.service.cmr.repository.ContentReader;
import org.alfresco.service.cmr.repository.NodeRef;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import ru.kristall.alfresco.module.bg.RecordCity;
import ru.kristall.alfresco.module.bg.RecordParam;
import ru.kristall.alfresco.module.bg.RecordReport;

public class LOVKriCity extends ListOfValuesConstraint implements Serializable {
	 
	org.alfresco.repo.jscript.ScriptLogger logger = new org.alfresco.repo.jscript.ScriptLogger();
 
	private static final long serialVersionUID=1;
 
 
	private String POSITIONS_XML = "FSetup/City.xml";
	private List<String> av = new ArrayList<String>();
	private List<RecordCity> ls = new ArrayList<RecordCity>();

 
	private static ServiceRegistry registry;
	private static Repository repository;
 
	public void setServiceRegistry(ServiceRegistry p)	{ registry = p; }
	public void setRepository(Repository p)             { repository = p; }

	public ServiceRegistry getServiceRegistry()	{ return registry; }
	public Repository getRepository()	        { return repository; }
 
	private List<String> allowedLabels;
 
	public void setAllowedValues(List allowedValues)    {}
 	public void setCaseSensitive(boolean caseSensitive) {}
	public void setAllowedLabels(List<String> p) { allowedLabels=p;}

	public List<String> getAllowedLabels() { return allowedLabels; }
	
	public List<RecordCity> getRR () {return ls;}
	public void clearRR() {ls=new ArrayList<RecordCity>();}
 
	public void initialize() {
		super.setCaseSensitive(true);
		loadData();
	}
 
	public List getAllowedValues() {
		loadData();
		return super.getAllowedValues(); 
	}
 
 
 
	public List<SelectItem> getSelectItemList() {
		
		List<SelectItem> result = new ArrayList<SelectItem>(getAllowedValues().size());
		for(int i=0;i<getAllowedValues().size();i++) {
			result.add(new SelectItem((Object)getAllowedValues().get(i),allowedLabels.get(i)));
		}
		return result;
	}
 
	protected NodeRef getNodeRef(NodeRef parent, String path) {
		List<String> pathElements = new ArrayList<String>();
		StringTokenizer tokenizer = new StringTokenizer(path, "/");
		logger.error("getNodRef "+parent.toString());
		logger.error("getNodRef "+path);
		while (tokenizer.hasMoreTokens()) {
			String childName = tokenizer.nextToken();
			pathElements.add(childName);
		}
 
		NodeRef nodeRef = null;
		try {			
			nodeRef = registry.getFileFolderService().resolveNamePath(parent, pathElements).getNodeRef();
		}	catch(Exception fnfe)	{
			logger.error(" resolveNamePath ");
			logger.error(fnfe.getLocalizedMessage());
		}		
		return nodeRef;
	}
 
	public void parseXML(NodeRef xml) {
		ContentReader cr = registry.getFileFolderService().getReader(xml);
		logger.error("Content");
		logger.error(xml.toString());
		//InputStream is= cr.getContentInputStream();
        try{		
		  DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
          DocumentBuilder builder = factory.newDocumentBuilder();
          Document document = builder.parse(cr.getContentInputStream());
        
          Element root = document.getDocumentElement();
          logger.error("before root "+root.getNodeName());
          Element data=null;
          if (root.getNodeName().equalsIgnoreCase("Citys"))   data=root;
          else                                               data = (Element) root.getElementsByTagName("Reports").item(0);
          logger.error("after root "+data.getNodeName()+" "+data.getNodeValue());
                
          NodeList nodeList = data.getElementsByTagName("City");
        
          int length = nodeList.getLength();
          Element p=null;
          Element el=null;
          for (int i=0;i<length;i++) {
            el = (Element) nodeList.item(i);
            RecordCity rr = new RecordCity();
            //NodeList chield = el.getChildNodes();
            p= (Element) el.getElementsByTagName("Name").item(0);
            if (p!=null) rr.setName(p.getTextContent()); else rr.setName("");
            p= (Element) el.getElementsByTagName("Url").item(0);
            if (p!=null) rr.setUrl(p.getTextContent());   else rr.setUrl("");
            ls.add(rr);
          }
        }
        catch (Exception ex) {
        	logger.error("Error "+ex.getLocalizedMessage());
        }
	}
 
	protected void loadData() {
		logger.error("Begin lov load date"); 
		NodeRef companyHomeRef = null;
		try {
			companyHomeRef = getRepository().getCompanyHome();
		} catch(Exception ex){
			logger.error("Error getCompanyHome "+ex.toString());
		}
		List<String> av = new ArrayList<String>();
		List<String> al=new ArrayList<String>();
		if (companyHomeRef!=null) {
			logger.error("before getnoderef");
			NodeRef pNode = getNodeRef(companyHomeRef, POSITIONS_XML);
			logger.error("after getnoderef");
			logger.error (pNode.toString());
 
			if (pNode!=null) {
				if (ls.size()>0) {ls.clear();}
				al.clear();
				av.clear();
				parseXML(pNode);
				logger.error("ls.size()="+ls.size());
				for (int i=0;i<ls.size();i++) {
					al.add(i, ls.get(i).getName());
					av.add(i, ls.get(i).getName());
//					av.add(i, ls.get(i).getUrl());
				}
			} else logger.error("Unable to locate "+POSITIONS_XML+" path");
		}
 
		super.setAllowedValues(av);
		setAllowedLabels(al);
 
	}
}
